DevExtreme jQuery/JS - Overview

The DropDownBox is a widget that consists of a text field, which displays the current value, and a drop-down field, which can contain any UI element.

View Demo

The simplest widget configuration requires specifying a dataSource, value and contentTemplate. The following code adds the DropDownBox to your page:

JavaScript
  • $(function () {
  • const fruits = ["Apples", "Oranges", "Lemons", "Pears", "Pineapples"];
  • $("#dropDownBoxContainer").dxDropDownBox({
  • value: fruits[0],
  • dataSource: fruits,
  • contentTemplate: function(e) {
  • const $list = $("<div>").dxList({
  • dataSource: e.component.option("dataSource"),
  • selectionMode: "single",
  • onSelectionChanged: function(arg) {
  • e.component.option("value", arg.addedItems[0]);
  • e.component.close();
  • }
  • });
  • return $list;
  • }
  • });
  • });

If your data is an array of objects, specify:

  • valueExpr
    The data field whose value is written into the value option.
  • displayExpr
    The data field whose value is displayed in the input field of the widget.
JavaScript
  • $(function () {
  • const customers = [
  • { ID: 1, companyName: "Premier Buy", city: "Dallas", phone: "(233)2123-11" },
  • { ID: 2, companyName: "ElectrixMax", city: "Naperville", phone: "(630)438-7800" },
  • // ...
  • ];
  • const selectedValue = customers[0].ID;
  • $("#dropDownBoxContainer").dxDropDownBox({
  • value: selectedValue,
  • valueExpr: "ID",
  • displayExpr: "companyName",
  • dataSource: new DevExpress.data.ArrayStore({
  • data: customers,
  • key: "ID"
  • }),
  • contentTemplate: function(e){
  • const $dataGrid = $("<div>").dxDataGrid({
  • dataSource: e.component.option("dataSource"),
  • columns: ["companyName", "city", "phone"],
  • height: 265,
  • selection: { mode: "single" },
  • selectedRowKeys: [selectedValue],
  • onSelectionChanged: function(selectedItems){
  • const keys = selectedItems.selectedRowKeys,
  • hasSelection = keys.length;
  • e.component.option("value", hasSelection ? keys[0] : null);
  • e.component.close();
  • }
  • });
  • return $dataGrid;
  • }
  • });
  • });
See Also

DevExtreme Angular - Overview

The DropDownBox is a widget that consists of a text field, which displays the current value, and a drop-down field, which can contain any UI element.

View Demo

The simplest widget configuration requires specifying a dataSource, value and contentTemplate. The following code adds the DropDownBox to your page:

jQuery
JavaScript
$(function () {
    var fruits = ["Apples", "Oranges", "Lemons", "Pears", "Pineapples"];
    $("#dropDownBoxContainer").dxDropDownBox({
        value: fruits[0],
        dataSource: fruits,
        contentTemplate: function(e) {
            var $list = $("<div>").dxList({
                dataSource: e.component.option("dataSource"),
                selectionMode: "single",
                onSelectionChanged: function(arg) {
                    e.component.option("value", arg.addedItems[0]);
                    e.component.close();
                } 
            });
            return $list;
        }
    });
});
Angular
HTML
TypeScript
<dx-drop-down-box
    [(value)]="selectedFruit"
    [(opened)]="isDropDownBoxOpened"
    [dataSource]="fruits">
    <div *dxTemplate="let contentData of 'content'">
        <dx-list 
            [dataSource]="fruits"
            selectionMode="single"
            (onSelectionChanged)="changeDropDownBoxValue($event)">
        </dx-list>
    </div>
</dx-drop-down-box>
import { DxDropDownBoxModule, DxListModule } from "devextreme-angular";
// ...
export class AppComponent {
    fruits = ["Apples", "Oranges", "Lemons", "Pears", "Pineapples"];
    selectedFruit = this.fruits[0];
    isDropDownBoxOpened = false;
    changeDropDownBoxValue = function (args) {
        this.selectedFruit = args.addedItems[0];
        this.isDropDownBoxOpened = false;
    }
}
@NgModule({
    imports: [
        // ...
        DxDropDownBoxModule,
        DxListModule
    ],
    // ...
})

If your data is an array of objects, specify:

  • valueExpr
    The data field whose value is written into the value option.
  • displayExpr
    The data field whose value is displayed in the input field of the widget.
jQuery
JavaScript
$(function () {
    var customers = [
        { id: 1, companyName: "Premier Buy", city: "Dallas", phone: "(233)2123-11" }
        // ...
    ];
    var selectedValue = customers[0].id;
    $("#dropDownBoxContainer").dxDropDownBox({
        value: selectedValue,
        valueExpr: "id",
        displayExpr: "companyName",
        dataSource: new DevExpress.data.ArrayStore({
            data: customers,
            key: "id"
        }),
        contentTemplate: function(e){
            var $dataGrid = $("<div>").dxDataGrid({
                dataSource: e.component.option("dataSource"),
                columns: ["companyName", "city", "phone"],
                height: 265,
                selection: { mode: "single" },
                selectedRowKeys: [selectedValue],
                onSelectionChanged: function(selectedItems){
                    var keys = selectedItems.selectedRowKeys,
                        hasSelection = keys.length;
                    e.component.option("value", hasSelection ? keys[0] : null); 
                    e.component.close();
                }
            });
            return $dataGrid;
        }
    });
});
Angular
HTML
TypeScript
<dx-drop-down-box
    [(value)]="selectedCustomers"
    [(opened)]="isDropDownBoxOpened"
    valueExpr="id"
    displayExpr="companyName"
    [dataSource]="customerDataSource">
    <div *dxTemplate="let contentData of 'content'">
        <dx-data-grid 
            [dataSource]="customerDataSource"
            [selection]="{ mode: 'single' }"
            [columns]="['companyName', 'city', 'phone']"
            [height]="265"
            [(selectedRowKeys)]="selectedCustomers"
            (onSelectionChanged)="changeDropDownBoxValue($event)">
        </dx-data-grid>
    </div>
</dx-drop-down-box>
import { DxDropDownBoxModule, DxDataGridModule } from "devextreme-angular";
import ArrayStore from "devextreme/data/array_store";
// ...
export class AppComponent  {
    customers = [
        { id: 1, companyName: "Premier Buy", city: "Dallas", phone: "(233)2123-11" },
        // ...
    ];
    customerDataSource = new ArrayStore({
        data: this.customers,
        key: "id"
    });
    selectedCustomers = [this.customers[1].id];
    isDropDownBoxOpened = false;
    changeDropDownBoxValue = function (args) {
        this.isDropDownBoxOpened = false;
    }
}
@NgModule({
    imports: [
        // ...
        DxDropDownBoxModule,
        DxDataGridModule
    ],
    // ...
})
See Also

DevExtreme React - Overview

The DropDownBox is a widget that consists of a text field, which displays the current value, and a drop-down field, which can contain any UI element.

View Demo

The simplest widget configuration requires specifying a dataSource, value and contentTemplate. The following code adds the DropDownBox to your page:

  • import React from 'react';
  • import 'devextreme/dist/css/dx.common.css';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { DropDownBox } from 'devextreme-react/drop-down-box';
  • import { List } from 'devextreme-react/list';
  •  
  • const fruits = ['Apples', 'Oranges', 'Lemons', 'Pears', 'Pineapples'];
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.state = {
  • selectedFruit: fruits[0]
  • };
  •  
  • this.dataSource = fruits;
  • this.dropDownBoxRef = React.createRef();
  •  
  • this.changeDropDownBoxValue = this.changeDropDownBoxValue.bind(this);
  • }
  •  
  • changeDropDownBoxValue(e) {
  • this.setState({
  • selectedFruit: e.addedItems[0]
  • });
  • this.dropDownBoxRef.current.instance.close();
  • }
  •  
  • render() {
  • return (
  • <DropDownBox
  • ref={this.dropDownBoxRef}
  • value={this.state.selectedFruit}
  • dataSource={this.dataSource}>
  • <List
  • dataSource={this.dataSource}
  • selectionMode="single"
  • onSelectionChanged={this.changeDropDownBoxValue}
  • />
  • </DropDownBox>
  • );
  • }
  • }
  •  
  • export default App;

If your data is an array of objects, specify:

  • valueExpr
    The data field whose value is written into the value option.
  • displayExpr
    The data field whose value is displayed in the input field of the widget.
  • import React from 'react';
  • import 'devextreme/dist/css/dx.common.css';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { DropDownBox } from 'devextreme-react/drop-down-box';
  • import { DataGrid, Selection } from "devextreme-react/data-grid";
  • import ArrayStore from "devextreme/data/array_store";
  •  
  • const customers = [
  • { ID: 1, companyName: "Premier Buy", city: "Dallas", phone: "(233)2123-11" },
  • { ID: 2, companyName: "ElectrixMax", city: "Naperville", phone: "(630)438-7800" },
  • // ...
  • ];
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.state = {
  • selectedCustomers: [customers[0].ID],
  • selectedValue: customers[0].ID
  • };
  •  
  • this.customerDataSource = new ArrayStore({
  • data: customers,
  • key: "ID"
  • });
  • this.dropDownBoxRef = React.createRef();
  •  
  • this.changeDropDownBoxValue = this.changeDropDownBoxValue.bind(this);
  • }
  •  
  • changeDropDownBoxValue(selectedItems) {
  • const keys = selectedItems.selectedRowKeys;
  • this.setState({
  • selectedCustomers: keys,
  • selectedValue: keys[0]
  • });
  •  
  • this.dropDownBoxRef.current.instance.close();
  • }
  •  
  • render() {
  • return (
  • <DropDownBox
  • ref={this.dropDownBoxRef}
  • value={this.state.selectedValue}
  • dataSource={this.customerDataSource}
  • valueExpr="ID"
  • displayExpr="companyName">
  • <DataGrid
  • dataSource={this.customerDataSource}
  • columns={['companyName', 'city', 'phone']}
  • height={265}
  • selectedRowKeys={this.state.selectedCustomers}
  • onSelectionChanged={this.changeDropDownBoxValue}>
  • <Selection mode="single"/>
  • </DataGrid>
  • </DropDownBox>
  • );
  • }
  • }
  •  
  • export default App;
See Also